/*!
  \file   Cubature.C
  \brief  Cubature
*/
#include <iostream>
#include "nisp_pc.h"
#include "nisp_util.h"

using namespace std;

/*!
  \fn void Cubature(int niveau)
  \brief Methode : Quadrature, Petras, SmolyakGauss, SmolyakFejer
  \param niveau niveau de la cubature
*/
void Cubature(int nx, int niveau) {

  // Definition de nx variables uniformes
  SetRandomVariable * gx = new SetRandomVariable(nx);

  gx->BuildSample((char *) "Quadrature",niveau);
  gx->Save((char *) "Quadrature.dat");
  cout << "Quadrature = " << gx->GetSize() << endl;

  gx->BuildSample("SmolyakGauss",niveau);
  gx->Save((char *) "SmolyakGauss.dat");
  cout << "SmolyakGauss = " << gx->GetSize() << endl;

  gx->BuildSample("Petras",niveau);
  gx->Save((char *) "Petras.dat");
  cout << "Petras = " << gx->GetSize() << endl;

  gx->BuildSample("SmolyakClenshawCurtis",niveau);
  gx->Save((char *) "SmolyakClenshawCurtis.dat");
  cout << "SmolyakClenshawCurtis = " << gx->GetSize() << endl;

  gx->BuildSample("SmolyakFejer",niveau);
  gx->Save((char *) "SmolyakFejer.dat");
  cout << "SmolyakFejer = " << gx->GetSize() << endl;

  gx->BuildSample("SmolyakTrapeze",niveau);
  gx->Save((char *) "SmolyakTrapeze.dat");
  cout << "SmolyakTrapeze= " << gx->GetSize() << endl;

  
}

int main(int argc, char *argv[]) {
  if(argc != 3) {
    cout << "Commande < nisp nx niveau >" << endl;
    cout << "nx     : dimension stochastique" << endl;
    cout << "niveau : niveau de la cubature" << endl;
  }
  else {
    int nx=atoi(argv[1]);
    int niveau=atoi(argv[2]);
    Cubature(nx, niveau);
  }
}
