// 2009 - INRIA - Michael Baudin
#ifndef _NISP_BLAS1_D_H_
#define _NISP_BLAS1_D_H_

#ifdef _MSC_VER
	#if LIBNISP_EXPORTS 
		#define NISP_IMPORTEXPORT __declspec (dllexport)
	#else
		#define NISP_IMPORTEXPORT __declspec (dllimport)
	#endif
#else
	#define NISP_IMPORTEXPORT
#endif

#ifdef __cplusplus
extern "C" {
#endif 

NISP_IMPORTEXPORT double dasum ( int n, double x[], int incx );
NISP_IMPORTEXPORT void daxpy ( int n, double da, double dx[], int incx, double dy[], int incy );
NISP_IMPORTEXPORT void dcopy ( int n, double dx[], int incx, double dy[], int incy );
NISP_IMPORTEXPORT double ddot ( int n, double dx[], int incx, double dy[], int incy );
NISP_IMPORTEXPORT double dmach ( int job );
NISP_IMPORTEXPORT double dnrm2 ( int n, double x[], int incx );
NISP_IMPORTEXPORT void drot ( int n, double x[], int incx, double y[], int incy, double c, double s );
NISP_IMPORTEXPORT void drotg ( double *sa, double *sb, double *c, double *s );
NISP_IMPORTEXPORT void dscal ( int n, double sa, double x[], int incx );
NISP_IMPORTEXPORT void dswap ( int n, double x[], int incx, double y[], int incy );
NISP_IMPORTEXPORT int i4_max ( int i1, int i2 );
NISP_IMPORTEXPORT int i4_min ( int i1, int i2 );
NISP_IMPORTEXPORT int idamax ( int n, double dx[], int incx );
NISP_IMPORTEXPORT bool lsame ( char ca, char cb );
NISP_IMPORTEXPORT double r8_abs ( double x );
NISP_IMPORTEXPORT double r8_max ( double x, double y );
NISP_IMPORTEXPORT double r8_sign ( double x );
NISP_IMPORTEXPORT void xerbla ( char *srname, int info );

#ifdef __cplusplus
}
#endif 

#endif /* _NISP_BLAS1_D_H_ */


