// 2009 - INRIA - Michael Baudin
#ifndef _NISP_LINPACK_D_H_
#define _NISP_LINPACK_D_H_

#ifdef _MSC_VER
	#if LIBNISP_EXPORTS 
		#define NISP_IMPORTEXPORT __declspec (dllexport)
	#else
		#define NISP_IMPORTEXPORT __declspec (dllimport)
	#endif
#else
	#define NISP_IMPORTEXPORT
#endif

#ifdef __cplusplus
extern "C" {
#endif 

NISP_IMPORTEXPORT int dchdc ( double a[], int lda, int p, double work[], int ipvt[], int job );
NISP_IMPORTEXPORT int dchdd ( double r[], int ldr, int p, double x[], double z[], int ldz, 
  int nz, double y[], double rho[], double c[], double s[] );
NISP_IMPORTEXPORT void dchex ( double r[], int ldr, int p, int k, int l, double z[], int ldz, 
  int nz, double c[], double s[], int job );
NISP_IMPORTEXPORT void dchud ( double r[], int ldr, int p, double x[], double z[], int ldz, 
  int nz, double y[], double rho[], double c[], double s[] );
NISP_IMPORTEXPORT double dgbco ( double abd[], int lda, int n, int ml, int mu, int ipvt[], 
  double z[] );
NISP_IMPORTEXPORT void dgbdi ( double abd[], int lda, int n, int ml, int mu, int ipvt[], 
  double det[2] );
NISP_IMPORTEXPORT int dgbfa ( double abd[], int lda, int n, int ml, int mu, int ipvt[] );
NISP_IMPORTEXPORT void dgbsl ( double abd[], int lda, int n, int ml, int mu, int ipvt[], 
  double b[], int job );
NISP_IMPORTEXPORT double dgeco ( double a[], int lda, int n, int ipvt[], double z[] );
NISP_IMPORTEXPORT void dgedi ( double a[], int lda, int n, int ipvt[], double det[], 
  double work[], int job );
NISP_IMPORTEXPORT int dgefa ( double a[], int lda, int n, int ipvt[] );
NISP_IMPORTEXPORT void dgesl ( double a[], int lda, int n, int ipvt[], double b[], int job );
NISP_IMPORTEXPORT int dgtsl ( int n, double c[], double d[], double e[], double b[] );
NISP_IMPORTEXPORT double dpbco ( double abd[], int lda, int n, int m, double z[] );
NISP_IMPORTEXPORT void dpbdi ( double abd[], int lda, int n, int m, double det[] );
NISP_IMPORTEXPORT int dpbfa ( double abd[], int lda, int n, int m );
NISP_IMPORTEXPORT void dpbsl ( double abd[], int lda, int n, int m, double b[] );
NISP_IMPORTEXPORT double dpoco ( double a[], int lda, int n, double z[] );
NISP_IMPORTEXPORT void dpodi ( double a[], int lda, int n, double det[], int job );
NISP_IMPORTEXPORT int dpofa ( double a[], int lda, int n );
NISP_IMPORTEXPORT void dposl ( double a[], int lda, int n, double b[] );
NISP_IMPORTEXPORT double dppco ( double ap[], int n, double z[] );
NISP_IMPORTEXPORT void dppdi ( double ap[], int n, double det[2], int job );
NISP_IMPORTEXPORT int dppfa ( double ap[], int n );
NISP_IMPORTEXPORT void dppsl ( double ap[], int n, double b[] );
NISP_IMPORTEXPORT void dptsl ( int n, double d[], double e[], double b[] );
NISP_IMPORTEXPORT void dqrdc ( double a[], int lda, int n, int p, double qraux[], int jpvt[], 
  double work[], int job );
NISP_IMPORTEXPORT int dqrsl ( double a[], int lda, int n, int k, double qraux[], double y[], 
  double qy[], double qty[], double b[], double rsd[], double ab[], int job );
NISP_IMPORTEXPORT double dsico ( double a[], int lda, int n, int kpvt[], double z[] );
NISP_IMPORTEXPORT void dsidi ( double a[], int lda, int n, int kpvt[], double det[2], 
  int inert[3], double work[], int job );
NISP_IMPORTEXPORT int dsifa ( double a[], int lda, int n, int kpvt[] );
NISP_IMPORTEXPORT void dsisl ( double a[], int lda, int n, int kpvt[], double b[] );
NISP_IMPORTEXPORT double dspco ( double ap[], int n, int kpvt[], double z[] );
NISP_IMPORTEXPORT void dspdi ( double ap[], int n, int kpvt[], double det[2], int inert[3], 
  double work[], int job );
NISP_IMPORTEXPORT int dspfa ( double ap[], int n, int kpvt[] );
NISP_IMPORTEXPORT void dspsl ( double ap[], int n, int kpvt[], double b[] );
NISP_IMPORTEXPORT int dsvdc ( double a[], int lda, int m, int n, double s[], double e[], 
  double u[], int ldu, double v[], int ldv, double work[], int job );
NISP_IMPORTEXPORT double dtrco ( double t[], int ldt, int n, double z[], int job );
NISP_IMPORTEXPORT int dtrdi ( double t[], int ldt, int n, double det[], int job );
NISP_IMPORTEXPORT int dtrsl ( double t[], int ldt, int n, double b[], int job );

#ifdef __cplusplus
}
#endif 

#endif /* _NISP_LINPACK_D_H_ */


