// 2006-2009 - CEA - Jean-Marc Martinez
// 2009 - INRIA - Michael Baudin
#include <stdlib.h> // pour random
#include <math.h>

// nisp_randuni --
// Variable aleatoire nisp_uniforme entre 0 et 1
double nisp_randuni () {
  return(((double) rand()) / ((double) RAND_MAX));
}

// Variable aleatoire nisp_exponentielle $exp(-x)$
double nisp_randexp () {
  double dum;
  // TODO : why 1.e-100 ???
  do {
    dum = nisp_randuni ();
  }
  while (dum < 1.e-100);
  return -log(dum);
}

// Variable alatoire nisp_normale standardisee
double nisp_randnor () {
  static int    flip = 0;
  static double y;
  double fac, rho, x1 , x2;
  if  (flip == 0) {
    do {
      x1  = 2.0 * nisp_randuni () - 1.0;
      x2  = 2.0 * nisp_randuni () - 1.0;
      rho = x1 * x1 + x2 * x2;
    }
    while (rho >= 1.0 || rho < 1.e-50);
    // TODO : why 1.e-50 ???
    fac = sqrt(-2.0 * log(rho) / rho);
    y = x1 * fac;
    flip = 1;
    return x2 * fac;
  }
  else 
  { 
	  flip = 0; 
	  return y; 
  }
}

