// ====================================================================
// Michael Baudin
// This file is released into the public domain
// ====================================================================

//
// builder.sce --
//   Builder for the NISP Scilab Toolbox
//

mode(-1);
lines(0);

try
	getversion("scilab");
catch
	error(gettext("Scilab 5.0 or more is required."));  
end

// ====================================================================

if ~with_module("development_tools") then
  error(msprintf(gettext("%s module not installed."),"development_tools"));
end

// ====================================================================

TOOLBOX_NAME      = "NISP";
TOOLBOX_TITLE     = "NISP Toolbox";

// ====================================================================

toolbox_dir = get_absolute_file_path("builder.sce");

exec(pathconvert(toolbox_dir+"/NISP_library/builder_NISP_library.sce",%F));

tbx_builder_gateway(toolbox_dir);
tbx_builder_help(toolbox_dir);
tbx_build_loader(TOOLBOX_NAME,toolbox_dir);

// ====================================================================

clear toolbox_dir TOOLBOX_NAME TOOLBOX_TITLE;
