
// Copyright (C) 2008 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

extern "C" {
#include "stack-c.h" 
#include "Scierror.h"
#include "localization.h"
#include "gw_nisp.h"
}


/* ==================================================================== */

#include "nisp_gwsupport.hxx" 
#include "nisp_PolynomialChaos_map.hxx" 


/* ==================================================================== */
// 
// polychaos_propagateinput ( token )
//   propagate an input which has been set with setinput
// polychaos_propagateinput ( token , value )
//   propagate the given input data, with value a 1 x (nx) matrix, with 
//   nx the number of input random variables.
//
int sci_polychaos_propagateinput (char *fname)
{
	int nRows, nCols;
	int token;
	PolynomialChaos * pc = NULL;
	double * inputvector;
	int nx;

	CheckRhs(1,2) ;
	CheckLhs(0,1) ;
	nisp_gettoken ( fname , 1 , &token );
	if (Rhs==2) {
		nisp_AssertVarType(fname , 2 , sci_matrix );
		GetRhsVarMatrixDouble ( 2, &nRows, &nCols, &inputvector);
	}
	nisp_token2Polychaos ( fname , 1 , token , &pc );
	if (Rhs==1) {
		pc->PropagateInput();
	} else if (Rhs==2) {
		nx = pc-> GetDimensionInput();
		nisp_AssertNRows ( fname , 2 , nRows , 1 );
		nisp_AssertNColumns ( fname , 2 , nCols , nx );
		pc->PropagateInput(inputvector);

	}
	nisp_CreateLhsInteger ( 1 , token );
	return 0;
}
/* ==================================================================== */

