
// Copyright (C) 2008 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

extern "C" {
#include "stack-c.h" 
#include "Scierror.h"
#include "localization.h"
#include "gw_nisp.h"
}


/* ==================================================================== */

#include "nisp_gwsupport.hxx" 
#include "nisp_PolynomialChaos_map.hxx" 


/* ==================================================================== */
// 
// polychaos_setinput ( token , ivar , value )
//   set the input corresponding to input variable ivar, where 1<= ivar<= nx
// polychaos_setinput ( token , value )
//   set the input as a 1 x (nx) matrix
//
int sci_polychaos_setinput (char *fname)
{
	int nRows, nCols;
	int token;
	PolynomialChaos * pc = NULL;
	double * inputvector;
	int nx;
	double value;
	int ivar;

	CheckRhs(2,3) ;
	CheckLhs(0,1) ;
	nisp_gettoken ( fname , 1 , &token );
	if (Rhs==2) {
		nisp_AssertVarType(fname , 2 , sci_matrix );
		GetRhsVarMatrixDouble ( 2, &nRows, &nCols, &inputvector);
	} else if (Rhs == 3) {
		nisp_GetOneInteger ( fname , 2 , &ivar );
		nisp_GetOneDouble ( fname , 3 , &value );
	}
	nisp_token2Polychaos ( fname , 1 , token , &pc );
	if (Rhs==2) {
		nx = pc-> GetDimensionInput();
		nisp_AssertNRows ( fname , 2 , nRows , 1 );
		nisp_AssertNColumns ( fname , 2 , nCols , nx );
		pc->SetInput(inputvector);
	} else if (Rhs==3) {
		pc->SetInput ( ivar , value );
	}
	nisp_CreateLhsInteger ( 1 , token );
	return 0;
}
/* ==================================================================== */

